;nyquist plug-in
;version 1
;type process
;categories "http://lv2plug.in/ns/lv2core/#AmplifierPlugin"
;name "Manual Duck (Simple)..."
;action "Fading Level..."
;info "By Steve Daulton www.easyspacepro.com.\nReleased under GPL v2.\n\nFades down level smoothly by specified amount,\nthen smoothly fades back up to original level.\nFade time is a percentage of the selection length.\nReducing by more than 96 dB will cut to silence.\n"

;; ManualDuck.ny by Steve Daulton April 2012
;; Released under terms of the GNU General Public License version 2:
;; http://www.gnu.org/licenses/old-licenses/gpl-2.0.html .

;control Reduce "Reduce Gain by" real "dB" 12 0 100
;control FadeLength "Fade Length" real "%" 25 0 50

(defun duck (sig FLen cut)
  (setq cut (db-to-linear (* -1 cut)))
  (let ((MinLen (/ (get-duration 1)))) ; 0.01 seconds as %
    (setq FLen (* 0.01 (max (min FLen 50) MinLen))))
  (if (< cut (db-to-linear -96))(setq cut 0))
  (let* ((res (- 1 cut))
         (freq (/ (get-duration (* 2 FLen))))
         (fade (osc (hz-to-step freq) FLen *table* 90))
         (FadeOut (sum cut (mult 0.5 res (sum 1 fade))))
         (FadeIn (sum cut (mult -0.5 res (sum -1 fade))))
         (level (control-srate-abs *sound-srate* (const cut (- 1 (* 2 FLen)))))
         (fade (seq FadeOut level FadeIn)))
        (mult s fade)))
        
(if (> (get-duration 1) 0.02)
  (duck s FadeLength Reduce)
  (format nil "Error.~%Selection must be more than 20 ms."))